"use strict";

var _require = require("./index"),
    trans = _require.trans;

var bundleJson = require('../bundle.json');

module.exports = function (hpmApi) {
  registI18nResource(hpmApi);
  hpmApi.registerCmd('x2h', {
    description: hpmApi.i18n.getMessage("".concat(bundleJson.name, ".description")),
    options: {
      "-p, --preview": hpmApi.i18n.getMessage("".concat(bundleJson.name, ".preview"))
    },
    args: "<type>"
  }, function (options, args) {
    trans(args[0], options.preview, hpmApi);
  });
};

function registI18nResource(hpmApi) {
  var en = {
    "description": "Publish a package to HPM, support type 'gradle','maven','npm'",
    "argumentError": "arguments error: type is not supported!",
    "preview": "Only generate a tar package for checking and not to publish"
  };
  var zh = {
    "description": "把一个包发布到HPM, 支持的包类型有'gradle', 'maven'和'npm'",
    "argumentError": "参数错误: 类型不支持!",
    "preview": "只生成一个预览压缩包，不进行上传"
  };
  hpmApi.i18n.addLocalization("en", en, {
    pluginName: bundleJson.name
  });
  hpmApi.i18n.addLocalization("zh", zh, {
    pluginName: bundleJson.name
  });
}