"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.trans = trans;
exports.x2h = x2h;

var _shelljs = _interopRequireDefault(require("shelljs"));

var _publisher = _interopRequireDefault(require("./publisher"));

var _translatorFactory = _interopRequireDefault(require("./translatorFactory"));

var _utils = require("./utils");

var _bundle = _interopRequireDefault(require("../bundle.json"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function x2h() {
  var options = (0, _utils.parse)(process.argv);
  trans(options.pkgType, options.preview);
}

function trans() {
  var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "gradle";
  var preview = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var hpmApi = arguments.length > 2 ? arguments[2] : undefined;
  var dest = process.cwd();

  var translator = _translatorFactory["default"].createTranslator(type);

  if (translator == null) {
    if (hpmApi) {
      hpmApi.i18n.log("".concat(_bundle["default"].name, ".argumentError"));
    } else {
      console.log("arguments error: type is not supported!");
    }
  } else {
    translator.generateBundle(process.cwd(), dest, function () {
      var publisher = new _publisher["default"](dest);
      publisher.publish2Hpm(preview);

      _shelljs["default"].rm("-f", "bundle.json");
    });
  }
}