"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _translator = _interopRequireDefault(require("./translator"));

var _lowdb = _interopRequireDefault(require("lowdb"));

var _FileSync = _interopRequireDefault(require("lowdb/adapters/FileSync"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var MavenTranslator = /*#__PURE__*/function (_Translator) {
  _inherits(MavenTranslator, _Translator);

  var _super = _createSuper(MavenTranslator);

  function MavenTranslator() {
    _classCallCheck(this, MavenTranslator);

    return _super.call(this);
  }

  _createClass(MavenTranslator, [{
    key: "generateBundle",
    value: function generateBundle(cwd, dest, callback) {
      var pomParser = require("pom-parser");

      var opts = {
        filePath: _path["default"].join(cwd, this.getPomFileName())
      };
      var that = this;
      pomParser.parse(opts, function (err, pomResponse) {
        if (err) {
          console.log(err);
        }

        that.generate(dest, pomResponse.pomObject.project);
        callback();
      });
    }
  }, {
    key: "getPomFileName",
    value: function getPomFileName() {
      return "pom.xml";
    }
  }, {
    key: "generate",
    value: function generate(dest, inputJson) {
      var bundleJson = new _FileSync["default"](_path["default"].join(dest, "bundle.json"));
      var db = (0, _lowdb["default"])(bundleJson);
      db.set("name", this.extractName(inputJson)).value();
      db.set("version", inputJson.version).value();
      db.set("description", this.extractDescription(inputJson)).value();
      db.set("domain", "app").value();
      db.set("language", "java").value();
      db.set("publishAs", "binary").value();
      db.set("license", this.extractLicense(inputJson)).value();
      db.set("repository", this.extractRepository(inputJson)).value();
      db.set("homepage", this.extractHomepage(inputJson)).value();
      db.set("keywords", this.extractKeywords(inputJson)).value();
      db.set("tags", this.extractTags(inputJson)).value(); //不打包二进制文件
      // db.set("dirs", { bin: ["target/*.*ar", "build/bins/*.*ar"] }).value();

      db.defaults({
        _origin: inputJson
      }).value();
      db.write();
    }
  }, {
    key: "extractLicense",
    value: function extractLicense(pkg) {
      var lic = "unlicensed";

      if (pkg.licenses) {
        var license = pkg.licenses.license;

        if (license instanceof Array) {
          lic = license[0].name;
        } else {
          lic = license.name;
        }
      }

      return lic;
    }
  }, {
    key: "extractHomepage",
    value: function extractHomepage(pkg) {
      return pkg.url || "";
    }
  }, {
    key: "extractDescription",
    value: function extractDescription(pkg) {
      return pkg.description || pkg.name || "";
    }
  }, {
    key: "extractRepository",
    value: function extractRepository(pkg) {
      var repo = "";

      if (pkg.scm) {
        var scm = pkg.scm;

        if (scm.url) {
          repo = scm.url;
        }
      }

      return repo;
    }
  }, {
    key: "extractName",
    value: function extractName(pkg) {
      var bundleName = pkg.artifactid;

      if (pkg.properties) {
        bundleName = pkg.properties["hpm.bundle.name"] || pkg.artifactid;
      }

      return bundleName.toLowerCase().replace(/[\.-]/g, "_");
    }
  }, {
    key: "extractKeywords",
    value: function extractKeywords(pkg) {
      var keywords = "";

      if (pkg.properties) {
        keywords = pkg.properties["hpm.bundle.keywords"] || "";
      }

      return keywords.split(",").map(function (item) {
        return item.trim();
      }).filter(function (item) {
        return item;
      });
    }
  }, {
    key: "extractTags",
    value: function extractTags(pkg) {
      var tags = "";

      if (pkg.properties) {
        tags = pkg.properties["hpm.bundle.tags"] || "";
      }

      return tags.split(",").map(function (item) {
        return item.trim();
      }).filter(function (item) {
        return item;
      });
    }
  }]);

  return MavenTranslator;
}(_translator["default"]);

exports["default"] = MavenTranslator;