"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _translator = _interopRequireDefault(require("./translator"));

var _lowdb = _interopRequireDefault(require("lowdb"));

var _FileSync = _interopRequireDefault(require("lowdb/adapters/FileSync"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var NpmTranslator = /*#__PURE__*/function (_Translator) {
  _inherits(NpmTranslator, _Translator);

  var _super = _createSuper(NpmTranslator);

  function NpmTranslator() {
    _classCallCheck(this, NpmTranslator);

    return _super.call(this);
  }

  _createClass(NpmTranslator, [{
    key: "generateBundle",
    value: function generateBundle(cwd, dest, callback) {
      var inputJson = require(_path["default"].join(cwd, "package.json"));

      var outputJson = _path["default"].join(dest, "bundle.json");

      var bundleJson = new _FileSync["default"](outputJson);
      var db = (0, _lowdb["default"])(bundleJson);
      db.set("name", this.extractName(inputJson)).value();
      db.set("version", inputJson.version).value();
      db.set("description", inputJson.description || "").value();
      db.set("domain", "app").value();
      db.set("language", "javascript").value();
      db.set("publishAs", "source").value();
      db.set("license", this.extractLicense(inputJson)).value();
      db.set("repository", this.extractRepository(inputJson)).value();
      db.set("homepage", this.extractHomepage(inputJson)).value();
      db.set("keywords", this.extractKeywords(inputJson)).value();
      db.set("tags", this.extractTags(inputJson)).value();
      db.defaults({
        _origin: inputJson
      }).value();
      db.write();
      callback();
    }
  }, {
    key: "extractName",
    value: function extractName(pkg) {
      var manifest = pkg.hpm || {
        "bundle.name": pkg.name
      };
      return manifest["bundle.name"].toLowerCase().replace(/[\.-]/g, "_");
    }
  }, {
    key: "extractLicense",
    value: function extractLicense(pkg) {
      return pkg.license || "unlicensed";
    }
  }, {
    key: "extractHomepage",
    value: function extractHomepage(pkg) {
      return pkg.homepage || "";
    }
  }, {
    key: "extractRepository",
    value: function extractRepository(pkg) {
      var repo = "";

      if (pkg.repository) {
        repo = pkg.repository;

        if (repo.url) {
          repo = pkg.repository.url;
        }
      }

      return repo;
    }
  }, {
    key: "extractKeywords",
    value: function extractKeywords(pkg) {
      return pkg.keywords || [];
    }
  }, {
    key: "extractTags",
    value: function extractTags(pkg) {
      return pkg.tags || [];
    }
  }]);

  return NpmTranslator;
}(_translator["default"]);

exports["default"] = NpmTranslator;