"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _mavenTranslator = _interopRequireDefault(require("./mavenTranslator"));

var _gradleTranslator = _interopRequireDefault(require("./gradleTranslator"));

var _npmTranslator = _interopRequireDefault(require("./npmTranslator"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var TranslatorFactory = /*#__PURE__*/function () {
  function TranslatorFactory() {
    _classCallCheck(this, TranslatorFactory);
  }

  _createClass(TranslatorFactory, null, [{
    key: "createTranslator",
    value: function createTranslator(pkgType) {
      var result = null;

      if (pkgType === _utils.PKG_TYPE.MAVEN) {
        result = new _mavenTranslator["default"]();
      } else if (pkgType === _utils.PKG_TYPE.GRADLE) {
        result = new _gradleTranslator["default"]();
      } else if (pkgType === _utils.PKG_TYPE.NPM) {
        result = new _npmTranslator["default"]();
      }

      return result;
    }
  }]);

  return TranslatorFactory;
}();

exports["default"] = TranslatorFactory;